<template>
  <div class="app-container">
    <el-table
      v-loading="loading"
      :data="list.slice((pageNum-1)*pageSize,pageNum*pageSize)"
      style="width: 100%;"
    >
      <el-table-column label="序号" type="index" align="center">
        <template slot-scope="scope">
          <span>{{ (pageNum - 1) * pageSize + scope.$index + 1 }}</span>
        </template>
      </el-table-column>
      <el-table-column :show-overflow-tooltip="true" label="会话编号" align="center" prop="tokenId" />
      <el-table-column :show-overflow-tooltip="true" label="登录名称" align="center" prop="username" />
      <el-table-column label="真实姓名" align="center" prop="realname" width="100"/>
      <el-table-column :show-overflow-tooltip="true" label="登陆IP" align="center" prop="loginIp" />
      <el-table-column :show-overflow-tooltip="true" label="浏览器" align="center" prop="browser" />
      <el-table-column label="操作系统" align="center" prop="osName" width="90"/>
      <el-table-column :show-overflow-tooltip="true" label="角色" align="center" prop="roles"/>
      <el-table-column label="登录时间" align="center" prop="loginTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.loginTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="过期时间" align="center" prop="expireTime" width="85">
        <template slot-scope="scope">
          <el-tag type="danger">{{ scope.row.expireTime }}秒</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="90">
        <template slot-scope="scope">
          <el-button
            v-permission="['admin:monitor:online:forceLogout']"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleForceLogout(scope.row)"
          >强退</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="pageNum" :limit.sync="pageSize" />
  </div>
</template>

<script>
import { list, forceLogout } from '@/api/monitor/online'

export default {
  name: 'Online',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 总条数
      total: 0,
      // 表格数据
      list: [],
      page: 1,
      pageSize: 10
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询登录日志列表 */
    getList() {
      this.loading = true
      list().then(response => {
        this.list = response.data.data
        this.total = response.data.data.length
        this.loading = false
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 强退按钮操作 */
    handleForceLogout(row) {
      this.$confirm('是否确认强退名称为"' + row.username + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return forceLogout(row.tokenId)
      }).then(() => {
        this.getList()
        this.$notify.success({
          title: '成功',
          message: '强退成功'
        })
      }).catch(function() {})
    }
  }
}
</script>

